Base Distribution - Work Package # 45013

Status: Resolved Priority: Should have
Author: Sebastian Kurfuerst Category: General / Project
Created: 2013-01-31 Assigned To: Marc Neuhaus
Updated: 2014-01-30 Due date: 2013-04-20
Subject: Flexible plugin integration (TODO: Reviews)

Description

Flexible plugin integration

- Target Audience: developers and integrators who want to use Neos
Responsible: Marc Neuhaus

- Implemented by: Marc Neuhaus, Bastian Waidelich

- Amount: 20 work days

- Version: must have for 1.0

Planned Implementation Timeframe: week 9 to 15, 2013

Motivation

About ten years ago when Kasper presented the first version of the Extension Kickstarter that was a little sensation and resulted in a
boost of contributions. Without it's extensibility and without the good old pibase TYPO3 would probably not be as popular as it is
today.

For Neos we want to provide a solid plugin foundation right from the start.

Goal

Neos already contains a plugin TypoScript object but the current implementation is very basic to say the least. We need to work on
that in order to make it very easy for people to write plugins and/or to turn Flow packages into a Neos plugin without having to mess
with the original package code.

What has been started at #40599 will be used as base for this.

Deliverables

- MUST: Polished Backend UX (as described in #40599)
- MUST: "touchless" integration of Flow packages
- resolve links automatically
- overridable View configuration (change templates, view implementation & options without changing the original package, see
#42176)
- improve Fluid link/uri ViewHelpers (#35790)
- MUST: stable plugin API (provide a PluginService that can be used everywhere in order to fetch data about certain plugins &
plugin views)
- MUST: documentation (developer guide, integrator guide, step-by-step example)
- MUST: solid test coverage
- COULD: example plugin showing off all relevant features of the API

Subtasks:
Task # 46321: Plugins with Views should resolve their Links automatically Resolved
Task # 46322: Documentation for the Flexible plugin integration Resolved
Task # 46324: Example plugin showing off the Flexible plugin integration Resolved
Feature # 42176: Improve resolving of view Resolved
Story # 40599: Include arbitrary Flow-Applications as Plugins Resolved
Task # 44954: Provide a way to render PluginViews and PluginConfigurations in the Sidebar Resolved
Task # 46680: [FEATURE] Add ConfigurationProcessors for ContentTypes Resolved
Feature # 35790: allow f:link.action to operate on parent request Resolved
Task # 46857: Provide a PluginService as central API for Plugins and PluginViews Resolved
Related issues:
related to Base Distribution - Epic # 40296: EPIC: Plugin Support Resolved
http://forge.typo3.org/users/3273
http://forge.typo3.org/users/3273
http://forge.typo3.org/users/61

History

#1 - 2013-02-01 19:03 - Bastian Waidelich

- Subject changed from [WIP] Stable Plugin Integration API -> TODO discuss to [WIP] Flexible plugin API
- Category set to General / Project

- Assigned To set to Bastian Waidelich

#2 - 2013-02-04 10:28 - Sebastian Kurfuerst

Hey Bastian,

thanks for your work on this! I'd like to go through this list with you again, to make the goals and deliverables more clear here :-) Just ping me when you

have some time!

Greets, Sebastian

#3 - 2013-02-05 13:59 - Bastian Waidelich

- Assigned To changed from Bastian Waidelich to Marc Neuhaus

#4 - 2013-02-05 16:09 - Bastian Waidelich
- Subject changed from [WIP] Flexible plugin API to Flexible plugin API

#5 - 2013-02-05 19:43 - Bastian Waidelich
- Subject changed from Flexible plugin API to Flexible plugin integration

#6 - 2013-02-16 14:59 - Sebastian Kurfuerst
- Status changed from New to Accepted

#7 - 2013-02-16 15:10 - Sebastian Kurfuerst
- File typo3neos-distribution-base-45013.pdf added
- Due date set to 2013-04-16

- Start date changed from 2013-01-31 to 2013-03-04
- Estimated time set to 120.00

Has been discussed with Jan-Hendrik from the EAB on 12.02.2013; and has been accepted on 15.02.2013 by the EAB.

(The attached PDF is a snapshot of this work package at the time of acceptance.)

So, Marc and Bastian, you can schedule this work package in your day-to-day calendar and implement it then -- can't wait to see it in Neos 1.0 :-)

Another side-note: Please do not forget to add comments to this work package and update "% done" while you are working on this package.

Greets, Sebastian

#8 - 2013-03-12 16:32 - Marc Neuhaus

I've created a Distribution that i'll use to work on this Workpackage:

https://github.com/mneuhaus/Workpackage.Flexible-plugin-integration

And i've created a really barebone Package for 'Contact Persons' that is in no way optimized as a Neos Plugin.
https://github.com/mneuhaus/Workpackage.Flexible-plugin-integration

The goal is to integrate this as neatly as possible without any Neos specific changes.

https://github.com/mneuhaus/Flowstarter.Contact

#9 - 2013-04-02 11:00 - Aske Ertmann

Would it make sense to set the due date to the end of week 15?

#10 - 2013-04-02 13:20 - Bastian Waidelich

Aske Ertmann wrote:

Would it make sense to set the due date to the end of week 157

FYI: You can't set the due date in this very issue. | set it by adding the due date to all open child issues

#11 - 2013-04-15 11:23 - Marc Neuhaus

This workpackage is ready to be reviewed :)

Here are all related Changesets in the flexible-plugin-integration topic:

https://review.typo3.org/#/q/status:open+branch:master+topic:flexible-plugin-integration,n,z

Video Demonstration:

http://www.youtube.com/watch?v=s67T1vAOmyc

Test it yourself:

| created a complete Distribution to make the testing simple:

https://github.com/mneuhaus/Workpackage.Flexible-plugin-integration

You can easily set it up like this:

composer create-project -s dev workpackage/flexible-plugin-integration fpi
cd fpi

[flow gerrit:update

/flow doctrine:migrate

[flow site:import --package-key TYPO3.NeosDemoTypo30rg

[flow user:create admin joh316 max mustermann

<pre>

#12 - 2013-05-16 10:10 - Sebastian Kurfuerst
- Subject changed from Flexible plugin integration to Flexible plugin integration (TODO: Reviews)

#13 - 2013-12-20 17:48 - Bastian Waidelich

Status update: All the changes have been merged in the meantime and the functionality has been stabilized with the release of Neos 1.0 on the 10th
of December. The demo site that comes with the default distribution contains a simple plugin that demonstrates most of the features of this work
package being:

0

0 - Plugin Views
https://github.com/mneuhaus/Flowstarter.Contact
https://review.typo3.org/#/q/status:open+branch:master+topic:flexible-plugin-integration,n,z
http://www.youtube.com/watch?v=s67T1vA0myc
https://github.com/mneuhaus/Workpackage.Flexible-plugin-integration

00 - Automatic link resolving

00 - A standard Flow controller as Plugin

0

Documentation of the plugin integration (#46322) is still somewhat sparse and could use some fine tuning

#14 - 2014-01-30 14:03 - Marc Neuhaus

- Status changed from Accepted to Resolved

Files

typo3neos-distribution-base-45013.pdf 4.3kB 2013-02-16 Sebastian Kurfuerst
